summaryrefslogtreecommitdiffstats
path: root/testing/source/libxml2/libxml2.SlackBuild
diff options
context:
space:
mode:
author Patrick J Volkerding <volkerdi@slackware.com>2023-12-09 19:55:12 +0000
committer Eric Hameleers <alien@slackware.com>2023-12-09 21:35:16 +0100
commit4f2f8fa3a5c832eb964c3e46084a072ecc592aa4 (patch)
tree3b4599dfea4253dd45b0acd04529f166f6064e53 /testing/source/libxml2/libxml2.SlackBuild
parentb130eee4bfa743a189a08a4da6ea9c28a7b02910 (diff)
downloadcurrent-4f2f8fa3a5c832eb964c3e46084a072ecc592aa4.tar.gz
current-4f2f8fa3a5c832eb964c3e46084a072ecc592aa4.tar.xz
Sat Dec 9 19:55:12 UTC 202320231209195512
kde/plasma-wayland-protocols-1.12.0-x86_64-1.txz: Upgraded. l/libxslt-1.1.39-x86_64-1.txz: Upgraded. l/zxing-cpp-2.2.0-x86_64-1.txz: Upgraded. xap/seamonkey-2.53.18-x86_64-1.txz: Upgraded. This is a bugfix release. For more information, see: https://www.seamonkey-project.org/releases/seamonkey2.53.18 testing/packages/libxml2-2.12.2-x86_64-1.txz: Upgraded. Hey folks, I'm in need of a bit of assistance here. I've had libxml2 on the back burner for quite some time now in spite of yet-another variation of the old "billion laughs" resource exhaustion attack that's been supposedly fixed. The issue I'm running into with newer versions of libxml2 is that the rewrite rules for mapping external entities to files on the system no longer work, and I'm not sure why that is. For a quick demonstration, upgrade to this libxml2 package and then try to build glib2. You'll see xsltproc called to generate documentation such as the man pages, but it isn't able to find the entity locally and fails due to --nonet. I'll be keeping an eye on LQ if anyone has any hints. Thanks!
Diffstat (limited to 'testing/source/libxml2/libxml2.SlackBuild')
-rwxr-xr-xtesting/source/libxml2/libxml2.SlackBuild163
1 files changed, 163 insertions, 0 deletions
diff --git a/testing/source/libxml2/libxml2.SlackBuild b/testing/source/libxml2/libxml2.SlackBuild
new file mode 100755
index 000000000..a102c23f6
--- /dev/null
+++ b/testing/source/libxml2/libxml2.SlackBuild
@@ -0,0 +1,163 @@
+#!/bin/bash
+
+# Copyright 2008, 2009, 2010, 2011, 2012, 2013, 2014, 2015, 2018, 2022, 2023 Patrick J. Volkerding, Sebeka, MN, USA
+# All rights reserved.
+#
+# Redistribution and use of this script, with or without modification, is
+# permitted provided that the following conditions are met:
+#
+# 1. Redistributions of this script must retain the above copyright
+# notice, this list of conditions and the following disclaimer.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR IMPLIED
+# WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
+# MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO
+# EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
+# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
+# PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
+# OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
+# WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
+# OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
+# ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+
+cd $(dirname $0) ; CWD=$(pwd)
+
+PKGNAM=libxml2
+VERSION=${VERSION:-$(echo $PKGNAM-*.tar.?z | rev | cut -f 3- -d . | cut -f 1 -d - | rev)}
+BUILD=${BUILD:-1}
+
+# Automatically determine the architecture we're building on:
+if [ -z "$ARCH" ]; then
+ case "$( uname -m )" in
+ i?86) export ARCH=i586 ;;
+ arm*) export ARCH=arm ;;
+ # Unless $ARCH is already set, use uname -m for all other archs:
+ *) export ARCH=$( uname -m ) ;;
+ esac
+fi
+
+# If the variable PRINT_PACKAGE_NAME is set, then this script will report what
+# the name of the created package would be, and then exit. This information
+# could be useful to other scripts.
+if [ ! -z "${PRINT_PACKAGE_NAME}" ]; then
+ echo "$PKGNAM-$VERSION-$ARCH-$BUILD.txz"
+ exit 0
+fi
+
+NUMJOBS=${NUMJOBS:-" -j$(expr $(nproc) + 1) "}
+
+if [ "$ARCH" = "i586" ]; then
+ SLKCFLAGS="-O2 -march=i586 -mtune=i686"
+ LIBDIRSUFFIX=""
+elif [ "$ARCH" = "s390" ]; then
+ SLKCFLAGS="-O2"
+ LIBDIRSUFFIX=""
+elif [ "$ARCH" = "x86_64" ]; then
+ SLKCFLAGS="-O2 -fPIC"
+ LIBDIRSUFFIX="64"
+else
+ SLKCFLAGS="-O2"
+ LIBDIRSUFFIX=""
+fi
+
+PYTHONLIB=$( python2 -c 'from distutils.sysconfig import get_python_lib; print(get_python_lib())' )
+PYTHON3LIB=$( python3 -c 'from distutils.sysconfig import get_python_lib; print(get_python_lib())' )
+
+TMP=${TMP:-/tmp}
+PKG=$TMP/package-libxml2
+rm -rf $PKG
+mkdir -p $TMP $PKG
+
+cd $TMP
+rm -rf libxml2-$VERSION
+tar xvf $CWD/libxml2-$VERSION.tar.?z || exit 1
+cd libxml2-$VERSION || exit 1
+chown -R root:root .
+find . \
+ \( -perm 777 -o -perm 775 -o -perm 711 -o -perm 555 -o -perm 511 \) \
+ -exec chmod 755 {} \+ -o \
+ \( -perm 666 -o -perm 664 -o -perm 600 -o -perm 444 -o -perm 440 -o -perm 400 \) \
+ -exec chmod 644 {} \+
+
+if [ ! -r configure ]; then
+ if [ -x ./autogen.sh ]; then
+ NOCONFIGURE=1 ./autogen.sh
+ else
+ autoreconf -vif
+ fi
+fi
+
+# Build for python2, for now...
+
+PYTHON=/usr/bin/python2 \
+CFLAGS="$SLKCFLAGS" \
+./configure \
+ --prefix=/usr \
+ --libdir=/usr/lib${LIBDIRSUFFIX} \
+ --mandir=/usr/man \
+ --docdir=/usr/doc/$PKGNAM-$VERSION \
+ --disable-static \
+ --with-python \
+ --build=$ARCH-slackware-linux || exit 1
+
+make $NUMJOBS || make || exit 1
+make install DESTDIR=$PKG || exit 1
+
+python2 -m compileall "${PKG}$PYTHONLIB"
+python2 -O -m compileall "${PKG}$PYTHONLIB"
+
+make clean
+
+# Next build for python3...
+
+## Fixes for python-3.9.x:
+#sed -i '/if Py/{s/Py/(Py/;s/)/))/}' python/{types.c,libxml.c}
+#sed -i '/_PyVerify_fd/,+1d' python/types.c
+#sed -i 's/test.test/#&/' python/tests/tstLastError.py
+
+# Patch from openSUSE.
+# See: https://bugzilla.gnome.org/show_bug.cgi?id=789714
+cat $CWD/libxml2-2.12.0-python3-unicode-errors.patch | patch -p1 --verbose || exit 1
+
+PYTHON=/usr/bin/python3 \
+CFLAGS="$SLKCFLAGS" \
+./configure \
+ --prefix=/usr \
+ --libdir=/usr/lib${LIBDIRSUFFIX} \
+ --mandir=/usr/man \
+ --docdir=/usr/doc/$PKGNAM-$VERSION \
+ --disable-static \
+ --with-python \
+ --build=$ARCH-slackware-linux || exit 1
+
+make $NUMJOBS || make || exit 1
+make install DESTDIR=$PKG || exit 1
+
+python3 -m compileall "${PKG}$PYTHON3LIB"
+python3 -O -m compileall "${PKG}$PYTHON3LIB"
+
+# Don't ship .la files:
+rm -f $PKG/{,usr/}lib${LIBDIRSUFFIX}/*.la
+
+find $PKG | xargs file | grep -e "executable" -e "shared object" | grep ELF \
+ | cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null
+
+mv $PKG/usr/share/doc/libxml2-python-$VERSION $PKG/usr/doc/libxml2-$VERSION
+rmdir $PKG/usr/share/doc
+cp -a \
+ AUTHORS* COPYING* Copyright* INSTALL* NEWS* README* TODO* \
+ $PKG/usr/doc/libxml2-$VERSION
+find $PKG/usr/doc/libxml2-$VERSION -type f | xargs chmod 644
+
+# Compress manual pages:
+find $PKG/usr/man -type f -exec gzip -9 {} \+
+for i in $( find $PKG/usr/man -type l ) ; do
+ ln -s $( readlink $i ).gz $i.gz
+ rm $i
+done
+
+mkdir -p $PKG/install
+cat $CWD/slack-desc > $PKG/install/slack-desc
+
+cd $PKG
+/sbin/makepkg -l y -c n $TMP/libxml2-$VERSION-$ARCH-$BUILD.txz